/*
   $Id: CommandAlign.h 648 2011-10-31 12:59:22Z manu $
*/
/*
 * Copyright INRA/CNRS - Thomas.Faraut@toulouse.inra.fr, Emmanuel.Courcelle@toulouse.inra.fr
 * This software is a computer program whose purpose is to align nucleic sequences, or perform other utility tasks
 * This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software.
 * 
 * Please read the file Licence_CeCILL-C_V1-en.txt which should have been distributed with this file
 * The fact that you are presently reading this, and the aforementioned file, means that you have had
 * knowledge of the CeCILL-C license and that you accept its terms.
*/

#ifndef COMMAND_ALIGN_H__
#define COMMAND_ALIGN_H__

#include "ParametersAlign.h"
#include "ParametersMap.h"
#include "ParametersSelf.h"
#include "ParametersMappe.h"
#include "Command.h" 

class CommandAlignMap: public Command {
	public:
		virtual int Main(int argc,char* argv[]);
		string AlignParametersUsage() const;	
		string ControllingAlignmentUsage() const;
		string InputFormatUsage() const;
		virtual string OutputFormatUsage() const;
		string OutputCompressionUsage() const;	
};
class CommandAlign: public CommandAlignMap {
	public:
		virtual void Usage() const;
	protected:
		virtual ParametersInitializer& _GetInitializer() { return __prm_init; };
	private:
		ParametersInitializerAlign __prm_init;
};
class CommandSelf: public CommandAlignMap {
	public:
		virtual void Usage() const;
	protected:
		virtual ParametersInitializer& _GetInitializer() { return __prm_init; };
	private:
		ParametersInitializerSelf __prm_init;
};

class CommandMap: public CommandAlignMap {
	public:
		virtual void Usage() const;
		string OutputFormatUsage() const;
		string MultiprocessorUsage() const;
	protected:
		virtual ParametersInitializer& _GetInitializer() { return __prm_init; };
	private:
		ParametersInitializerMap __prm_init;	
};

class CommandMappe: public CommandMap {
	public:
		virtual void Usage() const;
		virtual string OutputFormatUsage() const;
	protected:
		virtual ParametersInitializer& _GetInitializer() { return __prm_init; };
	private:
		ParametersInitializerMappe __prm_init;	
};
#endif

